import Cocoa
import Quartz
import PlaygroundSupport
import MetalPerformanceShaders

print(MTLCopyAllDevices())

let device = MTLCopyAllDevices()[0]

var intListResult: [Int] = []

let descriptor = MPSMatrixDescriptor.init(rows: 1, columns: 1, rowBytes: 4, dataType: .float32)

let shaderKernel = MPSMatrixSum.init(device: device, count: 9500, rows: 1, columns: 1, transpose: false)


var matrixList: [MPSMatrix] = []

    for i in 1...10000{
    let b: [Float32] = [Float32(i)]
        intListResult.append(i)
    
    let buffer = device.makeBuffer(bytes: b, length: 4, options: .storageModeManaged)

    let GPUStoredMatrices = MPSMatrix.init(buffer: buffer!, descriptor: descriptor)

    matrixList.append(GPUStoredMatrices)
        }

print(matrixList[10].debugDescription)
print(matrixList.count)
print(intListResult)

let matrices: [MPSMatrix] = matrixList

print(matrices.count)
print("\n")

let CMDQue = device.makeCommandQueue()

let CMDBuffer = CMDQue!.makeCommandBuffer()

var resultMatrixBuffer = device.makeBuffer(length: 4, options: .storageModeShared)

var resultMatrix = MPSMatrix.init(buffer: resultMatrixBuffer!, descriptor: MPSMatrixDescriptor.init(rows: 1, columns: 1, rowBytes: 4, dataType: .float32))
    
shaderKernel.encode(to: CMDBuffer!, sourceMatrices: matrices, resultMatrix: resultMatrix, scale: nil, offsetVector: nil, biasVector: nil, start: 0)

print(CMDBuffer.debugDescription)
let GPUStartTime = CACurrentMediaTime()
CMDBuffer!.commit()
print(CMDBuffer.debugDescription)
print(CMDQue.debugDescription)
CMDBuffer!.waitUntilCompleted()

var output = [Float32]()

let pointer = resultMatrix.data.contents()
let typedPointer = pointer.bindMemory(to: Float32.self, capacity: 1)
let buffpoint = UnsafeBufferPointer(start: typedPointer, count: 1)

buffpoint.map({value in
    output += [value]
})
print(output)
let finish = CACurrentMediaTime() - GPUStartTime
print("\n")
print(finish)
